# Class ExtensionBaseLayerListSettings`Abstract`

LayerListSettings bound to a LayerExtension or SublayerExtension.

#### Hierarchy (view full)

- LayerListSettings
  - ExtensionBaseLayerListSettings

#####
Index

### Constructors

constructor

### Properties

_extension
_initialChildrenIncluded
_initialExpanded
_initialIncluded

### Accessors

_esriLayer
_listModePath
_supportsChildren
childrenIncluded
effectivelyIncluded
expanded
included
initialChildrenIncluded
initialExpanded
initialIncluded

### Methods

_getSerializableProperties
_toPropertyDef
assignProperties
assignPropertiesAsync
finishAssignProperties
getDefault
getDefaults
getSerializableProperties
onLayerExtensionInitialized
toJSON

##
Constructors

### constructor

- new ExtensionBaseLayerListSettings(properties, extension, defaultChildrenIncluded?): ExtensionBaseLayerListSettings

- #### Parameters

  - properties: LayerListSettingsProperties
  - extension: LayerExtension<LayerExtensionProperties> | SublayerExtension<SublayerExtensionProperties>
  - `Optional` defaultChildrenIncluded: boolean

  #### Returns ExtensionBaseLayerListSettings

  Overrides LayerListSettings.constructor

##
Properties

### `Protected` `Readonly`_extension

_extension: LayerExtension<LayerExtensionProperties> | SublayerExtension<SublayerExtensionProperties>

The LayerExtension or SublayerExtension to which the Layer List settings apply.

### `Protected`_initialChildrenIncluded

_initialChildrenIncluded: boolean

Inherited from LayerListSettings._initialChildrenIncluded

### `Protected`_initialExpanded

_initialExpanded: boolean

Inherited from LayerListSettings._initialExpanded

### `Protected`_initialIncluded

_initialIncluded: boolean

Inherited from LayerListSettings._initialIncluded

##
Accessors

### `Protected` `Abstract`_esriLayer

- get _esriLayer():
  | Layer
  | BuildingGroupSublayer
  | BuildingComponentSublayer
  | Sublayer
  | SubtypeSublayer

- The Layer or Sublayer associated with the extension.

  #### Returns
  | Layer
  | BuildingGroupSublayer
  | BuildingComponentSublayer
  | Sublayer
  | SubtypeSublayer

### `Protected` `Abstract`_listModePath

- get _listModePath(): string

- The path to the listMode property, relative to the extension.

  #### Returns string

### `Protected` `Abstract`_supportsChildren

- get _supportsChildren(): boolean

- Whether the corresponding Layer/Sublayer Extension supports children.

  #### Returns boolean

### childrenIncluded

- get childrenIncluded(): boolean

- Whether child layers should be included in the layer list. This value may not be set to true, if the associated LayerExtension or SublayerExtension does not support sublayers.

  #### Returns boolean

  Overrides LayerListSettings.childrenIncluded

- set childrenIncluded(value): void

- Whether child layers should be included in the layer list. This value may not be set to true, if the associated LayerExtension or SublayerExtension does not support sublayers.

  #### Parameters

  - value: boolean

  #### Returns void

  Overrides LayerListSettings.childrenIncluded

### effectivelyIncluded

- get effectivelyIncluded(): boolean

- Whether this layer is effectively included in the layer list.

  #### Returns boolean

  Overrides LayerListSettings.effectivelyIncluded

### expanded

- get expanded(): boolean

- Whether this node is initially expanded to show children. No effect if included is false. This value may not be set to true, if the associated LayerExtension or SublayerExtension does not support sublayers.

  #### Returns boolean

  Overrides LayerListSettings.expanded

- set expanded(value): void

- Whether this node is initially expanded to show children. No effect if included is false. This value may not be set to true, if the associated LayerExtension or SublayerExtension does not support sublayers.

  #### Parameters

  - value: boolean

  #### Returns void

  Overrides LayerListSettings.expanded

### included

- get included(): boolean

- Whether this layer should be included in the layer list.

  #### Returns boolean

  Overrides LayerListSettings.included

- set included(value): void

- Whether this layer should be included in the layer list.

  #### Parameters

  - value: boolean

  #### Returns void

  Overrides LayerListSettings.included

### initialChildrenIncluded

- get initialChildrenIncluded(): boolean

- Initial value of the childrenIncluded property.

  #### Returns boolean

  Inherited from LayerListSettings.initialChildrenIncluded

### initialExpanded

- get initialExpanded(): boolean

- Initial value of the expanded property.

  #### Returns boolean

  Inherited from LayerListSettings.initialExpanded

### initialIncluded

- get initialIncluded(): boolean

- Initial value of the included property.

  #### Returns boolean

  Inherited from LayerListSettings.initialIncluded

##
Methods

### `Protected`_getSerializableProperties

- _getSerializableProperties(): PropertyDefs<LayerListSettingsProperties>

- The property keys and their metadata that are used to implement serializing and deserializing the class instance.

  #### Returns PropertyDefs<LayerListSettingsProperties>

  Overrides LayerListSettings._getSerializableProperties

### `Protected`_toPropertyDef

- _toPropertyDef<T>(def): PropertyDef<T>

- Converts the value to a PropertyDef object.

  #### Type Parameters

  - T

  #### Parameters

  - def: PropertyDefSerializeMode | PropertyDefSerializeMode[] | PropertyDef<T>

    The value to convert.

  #### Returns PropertyDef<T>

  Inherited from LayerListSettings._toPropertyDef

### assignProperties

- assignProperties(properties): void

- #### Parameters

  - properties: Partial<LayerListSettingsProperties>

  #### Returns void

  #### Inherit Doc

  Inherited from LayerListSettings.assignProperties

### assignPropertiesAsync

- assignPropertiesAsync(properties): Promise<void>

- #### Parameters

  - properties: Partial<LayerListSettingsProperties>

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from LayerListSettings.assignPropertiesAsync

### finishAssignProperties

- finishAssignProperties(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from LayerListSettings.finishAssignProperties

### getDefault

- getDefault<K>(key): LayerListSettingsProperties[K]

- #### Type Parameters

  - K extends keyof LayerListSettingsProperties

  #### Parameters

  - key: K

  #### Returns LayerListSettingsProperties[K]

  #### Inherit Doc

  Inherited from LayerListSettings.getDefault

### getDefaults

- getDefaults(): LayerListSettingsProperties

- #### Returns LayerListSettingsProperties

  #### Inherit Doc

  Inherited from LayerListSettings.getDefaults

### getSerializableProperties

- getSerializableProperties(serializeMode?): PropertyDefs<LayerListSettingsProperties>

- Returns the serializable properties.

  #### Parameters

  - serializeMode: SerializeMode = "all"

    Optional. If specified, only properties that support the given serialization mode will be returned.

  #### Returns PropertyDefs<LayerListSettingsProperties>

  Inherited from LayerListSettings.getSerializableProperties

### onLayerExtensionInitialized

- onLayerExtensionInitialized(): void

- Invoked when the parent layer extension is initialized.

  #### Returns void

### toJSON

- toJSON(serializeMode?): LayerListSettingsProperties

- #### Parameters

  - serializeMode: SerializeMode = "all"

  #### Returns LayerListSettingsProperties

  #### Inherit Doc

  Inherited from LayerListSettings.toJSON